//+------------------------------------------------------------------+
//|                                                MA ShortLines.mq4 |
//|                               coded by cja - cjatradingtools.com |
//+------------------------------------------------------------------+
#property copyright " coded by cja - cjatradingtools.com"

#property indicator_chart_window


 extern int Timeframe         = 0;
 extern int MA_Period         = 34;
 extern int MA_MODE           = 1;
 extern int MA_PRICE_TYPE     = 0;
 extern color MA_Color        = RoyalBlue;
 extern int MA_Width          = 1;
 extern int MA_Style          = 0;
 extern int Extend_MA_Line    = 1;
 
 extern bool Show_MA_Label    = true;
 extern bool Show_MA_Price    = true;
 extern bool Show_MA_TFrame   = true;
 extern int  MA_Label_Size    = 8;
 extern int  MA_Label_Shift   = 10;
 extern string  MA_Label_Font = "Vendana";
 string TF,TF1;
 int magic;
 int MA_Label_Shift2;
 string price,ma_mode;
 
 
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  
        	   	switch(Timeframe)
	{
		case 1:		TF="M1";  break;
		case 5:		TF="M5";  break;
		case 15:		TF="M15"; break;
		case 30:		TF="M30"; break;
		case 60:		TF="H1";  break;
		case 240:	TF="H4";  break;
		case 1440:	TF="D1";  break;
		case 10080:	TF="W1";  break;
		case 43200:	TF="MN1"; break;
		default:	  {Timeframe = Period(); init(); return(0);}
	}
      magic = Timeframe+MA_Period+MA_MODE+MA_PRICE_TYPE;
   
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   ObjectDelete("ma_line_1"+magic);
   ObjectDelete("ma_text_1"+magic);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
  
   double MA = iMA(NULL,Timeframe,MA_Period,0,MA_MODE,MA_PRICE_TYPE,0); 
   
   MALine("ma_line_1"+magic,0, MA,MA,MA_Width,MA_Style,MA_Color,true); 
   
   if(MA_MODE==0){ma_mode="SMA";} 
   if(MA_MODE==1){ma_mode="EMA";} 
   if(MA_MODE==2){ma_mode="SMMA";} 
   if(MA_MODE==3){ma_mode="LWMA";} 
   
   if(Show_MA_TFrame){TF=TF;}else{TF="";}
   MA_Label_Shift2 = MA_Label_Shift*100;
   
   
   if(Show_MA_Price){ price = " "+DoubleToStr(MA,Digits);}else{price = "               ";}
  
   if(Show_MA_Label){ 
   Text("ma_text_1"+magic,0,"                                        "+ma_mode+": "+MA_Period+"  "+TF+""+price ,MA_Label_Size,MA_Label_Font, MA_Color,(TimeCurrent()+(Period())*MA_Label_Shift2), MA,true);   
   }
     
   return(0);
  }
  
  
   void MALine(string ma, int Window,double start, double end,double w, double s,color clr, bool delete)
  {
   if (delete) ObjectDelete(ma);
   if(ObjectFind(ma)!=0)
     {
   ObjectCreate(ma, OBJ_TREND, 0,Time[Extend_MA_Line]+Period()*60,start,Time[0]+Period()*36000,end);
   ObjectSet(ma, OBJPROP_COLOR, clr);
   ObjectSet(ma,OBJPROP_RAY,false);
   ObjectSet(ma,OBJPROP_BACK,true);
   ObjectSet(ma,OBJPROP_WIDTH,w);
   ObjectSet(ma,OBJPROP_STYLE,s);
     }
   else
   ObjectMove(ma, 0,Time[Extend_MA_Line]+Period()*60,Time[0]+Period()*36000);
  }
  void Text(string TextName, int Window, string LabelText, int FontSize, string FontName, color TextColor, datetime Time1, double Price1, bool delete)
  {
   if (delete) ObjectDelete(TextName);
   if(ObjectFind(TextName)!=0)
     {
    ObjectCreate(TextName, OBJ_TEXT, Window, Time1,Price1);
    ObjectSetText(TextName, LabelText, FontSize, FontName, TextColor);
    ObjectSet(TextName,OBJPROP_BACK,true);
     }
   else
   ObjectMove(TextName, 0, Time1, Price1);
  } 
  
     

  
//+------------------------------------------------------------------+